@Echo off

Rem Belarus timezone change utility(UTC+3 Minsk)
Rem (c) Azarov Denis 01/10/2011
Rem mail to volk1234@mail.ru
Rem forum page http://www.oszone.net/16420/Daylight_Saving_Time
Rem v 0.5 15.10.2011

:set_start_time

Set start_time=%TIME:~0,-3%
Set start_time=%start_time::=%
Set start_time=%start_time: =0%
Set start_time=%DATE:~-4%%DATE:~3,2%%DATE:~0,2%_%start_time%

Rem Detecting OS,language and current tz registry key name
:DetectEnv

For /F "Tokens=3" %%A In ('Reg Query "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language" /V InstallLanguage') Do Set OSLang=%%A

For /F "Tokens=3*" %%A In ('Reg Query "HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion" /V CurrentVersion') Do Set OSver=%%A

If %OSver% GTR 5.2 (
Set Regkey4=HKLM\SYSTEM\CurrentControlSet\Control\TimeZoneInformation
) Else (
Set Regkey4=HKCU\Software\Microsoft\Windows NT\CurrentVersion\Time Zones
)

For /F "Tokens=2*" %%i In ('Reg Query "%Regkey4%" /V TimeZoneKeyName 2^>nul^|find /i "REG_SZ" 2^>nul') Do Set TZKN=%%j
If %OSver% == 5.2 Set TZKN=E. Europe Standard Time
Rem windows 2003r2 whithout updates had 'GTB Standart Time' timezonename for Minsk, not E. Europe Standard Time. And it have not tzchange util.

Rem Setting Variables
:TZVARS

Set Regkey1=HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Time Zones\%TZKN%
Set Regkey2=HKLM\SYSTEM\CurrentControlSet\Control\TimeZoneInformation
Set TZIdata="4cffffff00000000c4ffffff0000000000000000000000000000000000000000000000000000000000000000"
Set TZIdata2="88ffffff00000000c4ffffff00000a0000000500030000000000000000000300000005000200000000000000"
Set Dllres1="@tzres.dll,-1730"
Set Dllres2="@tzres.dll,-1731"
Set Dllres3="@tzres.dll,-1732"
Set DisplayEn="(UTC+03:00) Minsk"
Set DisplayRu="(UTC+03:00) "
Set DltEn=Minsk Daylight Time
Set StdEn=Minsk Standard Time
Set DltRu=᪮ ६ ()
Set StdRu=᪮ ६ ()
Set Backupdir="%TEMP%\TZBY\%start_time%"
Set Regkey3=HKLM\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Time Zones\%StdEn%

If "%OSLang%"=="0419" (
Goto :LangRu
) Else (
Goto :LangEn
)

:LangRu
Set DLT=%DltRu%
Set STD=%StdRu%
Set DSPL=%DisplayRu%
Goto :Regbackup

:LangEn
Set DLT=%DltEn%
Set STD=%StdEn%
Set DSPL=%DisplayEn%

Rem Backup regisry
:Regbackup

If Not Exist %Backupdir% MD %Backupdir%

REG EXPORT "%Regkey1%" %Backupdir%\TZ.reg >nul
REG EXPORT "%Regkey2%" %Backupdir%\TZI.reg >nul

Echo @Echo Off>>%Backupdir%\restore_tz.cmd
Echo. >>%Backupdir%\restore_tz.cmd
Echo Regedit /s TZ.reg>>%Backupdir%\restore_tz.cmd
Echo Regedit /s TZI.reg>>%Backupdir%\restore_tz.cmd
Echo Reg Delete "%Regkey3%" /f>>%Backupdir%\restore_tz.cmd
Echo. >>%Backupdir%\restore_tz.cmd
If %OSver% LEQ 5.2 (
Echo Tzchange /c "%TZKN%">>%Backupdir%\restore_tz.cmd
)
If %OSver% GTR 5.2 (
Echo Tzutil /s "%TZKN%">>%Backupdir%\restore_tz.cmd
)
Echo. >>%Backupdir%\restore_tz.cmd
Echo Exit /b0>>%Backupdir%\restore_tz.cmd

Rem Main: making settings for timezone utc +0300 Minsk
:SettingTZ

REG ADD "%Regkey3%" /v Dlt /t REG_SZ /d "%STD%" /f >nul
REG ADD "%Regkey3%" /v Std /t REG_SZ /d "%STD%" /f >nul
REG ADD "%Regkey3%" /v Display /t REG_SZ /d %DSPL% /f >nul
REG ADD "%Regkey3%\Dynamic DST" /v 2010 /t REG_BINARY /d %TZIdata2% /f >nul
REG ADD "%Regkey3%\Dynamic DST" /v 2011 /t REG_BINARY /d %TZIdata% /f >nul
REG ADD "%Regkey3%\Dynamic DST" /v FirstEntry /t REG_DWORD /d 0x000007da /f >nul
REG ADD "%Regkey3%\Dynamic DST" /v LastEntry /t REG_DWORD /d 0x000007db /f >nul
REG ADD "%Regkey3%" /v TZI /t REG_BINARY /d %TZIdata% /f >nul

If %OSver% GTR 5.2 (

      REG ADD "%Regkey3%" /v MUI_Display /t REG_SZ /d %Dllres1% /f >nul
      REG ADD "%Regkey3%" /v MUI_Std /t REG_SZ /d %Dllres2% /f >nul
      REG ADD "%Regkey3%" /v MUI_Dlt /t REG_SZ /d %Dllres3% /f >nul
      
      REG ADD "%Regkey2%" /v StandardName /t REG_SZ /d %Dllres2% /f >nul
      REG ADD "%Regkey2%" /v DaylightName /t REG_SZ /d %Dllres2% /f >nul
      REG ADD "%Regkey2%" /v DynamicDaylightTimeDisabled /t REG_DWORD /d 0x00000001 /f >nul
      REG ADD "%Regkey2%" /v TimeZoneKeyName /t REG_SZ /d "%StdEn%" /f >nul
      
      tzutil /s "%StdEn%"
)

If %OSver% LEQ 5.2 (

    tzchange /c "%StdEn%"
)


Exit /b0
